Google: Nano Banana Pro (Image to Image) API Reference

About

Google Nano Banana Pro (Gemini 3.0 Pro Image) Edit enables image editing with 4K-capable output. Ready-to-use REST inference API, best performance, no coldstarts, affordable pricing.

1. Calling the API

Setup your API Key

To begin using Infron, you first need to create an account and generate your API Key.

Once you have your API key, set it as an environment variable in your runtime environment. This allows your applications to securely access Infron’s API.

export INFRON_KEY="YOUR_API_KEY"

Submit a request

For long-running requests, you can poll for results.

curl https://media.onerouter.pro/v1/images/generations \
  -H "Authorization: Bearer YOUR_API_KEY" \
  -H "Content-Type: application/json" \
  -d @- <<'EOF'
{
    "model": "google/nano-banana-pro/image-to-image",
    "prompt": "make a photo of the man driving the car down the california coastline.",
    "image_urls": [
        "https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260603%2F53969087-23f8-4faa-a3c2-038bf80febf7.png",
        "https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260603%2Fa830ea54-af6f-469c-9488-59fca3394d85.png"
    ],
    "n": 1,
    "aspect_ratio": "16:9",
    "resolution": "1K",
    "output_format": "png",
    "response_format": "url",
    "seed": 1,
    "enable_web_search": true
}
EOF

Response with queue task id

The response will look like this:

{
  "code": 200,
  "message": "success",
  "data": {
    "task_id": "c4e4039558d8441cb7482d8d1dea668a",
    "object": "image",
    "model": "google/nano-banana-pro/image-to-image",
    "status": "created",
    "urls": {
      "query": "https://media.onerouter.pro/v1/images/tasks/c4e4039558d8441cb7482d8d1dea668a"
    },
    "created_at": "2026-06-04 06:57:07.12"
  }
}

Fetch request status

You can fetch the status of a request to check if it is completed or still in progress.

curl https://media.onerouter.pro/v1/images/tasks/{task_id} \
  -H "Authorization: Bearer YOUR_API_KEY" \
  -H "Content-Type: application/json" 

# For example
curl https://media.onerouter.pro/v1/images/tasks/c4e4039558d8441cb7482d8d1dea668a \
  -H "Authorization: Bearer YOUR_API_KEY" \
  -H "Content-Type: application/json"

Response with queue task status query

{
  "code": 200,
  "message": "success",
  "data": {
    "task_id": "c4e4039558d8441cb7482d8d1dea668a",
    "object": "image",
    "model": "google/nano-banana-pro/image-to-image",
    "status": "in_progress",
    "fail_reason": "",
    "submit_time": 1780556227,
    "start_time": 1780556227,
    "finish_time": 0,
    "outputs": [],
    "created_at": "2026-06-04 06:57:07"
  }
}

Possible statuses:

  • created
  • in_progress
  • processing
  • completed
  • failed

created -> in_progress → processing → completed | failed

Poll every 1-2 seconds until status is "completed" or "failed"

Get the result (when status is "completed")

Once the request is completed, you can fetch the result. See the Output Schema for the expected result format.

{
  "code": 200,
  "message": "success",
  "data": {
    "task_id": "c4e4039558d8441cb7482d8d1dea668a",
    "object": "image",
    "model": "google/nano-banana-pro/image-to-image",
    "status": "completed",
    "fail_reason": "",
    "submit_time": 1780556227,
    "start_time": 1780556227,
    "finish_time": 1780556257,
    "outputs": [
      "https://storage.googleapis.com/infron_gcs/image%2Fgemini_9f1e67c4-4381-4446-815c-226262c637df.png"
    ],
    "usage": {
      "completion_tokens": 1433,
      "image_count": 1,
      "prompt_tokens": 531,
      "resolution": "1K",
      "total_tokens": 1964,
      "web_search": true
    },
    "cost": {
      "total_cost": 0.138187,
      "cost_details": {
        "prompt_cost": 0,
        "completion_cost": 0,
        "image_cost": 0.138187,
        "video_cost": 0,
        "audio_cost": 0,
        "native_web_search_cost": 0,
        "plugin_web_search_cost": 0,
        "tools_cost": 0,
        "prompt_cache_read_cost": 0,
        "prompt_cache_write_cost": 0,
        "prompt_cache_write_5_min": 0,
        "prompt_cache_write_1_h": 0,
        "reasoning_cost": 0,
        "discount_rate": 1,
        "is_byok": false,
        "byok_cost": 0
      }
    },
    "created_at": "2026-06-04 06:57:07"
  }
}

2. Schema

Input

ParameterTypeRequiredDefaultRangeDescription
modelstringYes--Explore all modelsModel name.
promptstringYes----Text prompt for generation; Positive text prompt.
image_urlsarrayYes----Image URLs.
nintegerNo1==1Number of images to generate.
aspect_ratiostringNo--1:1, 2:3, 3:2, 3:4, 4:3, 4:5, 5:4, 9:16, 16:9, 21:9Aspect ratio of the generated image.
resolutionstringNo1K1K, 2K, 4KResolution of the generated image.
output_formatstringNopngpng, jpeg, webpOutput format for the images.
response_formatstringNourlurl, b64_jsonURL or JSON string.
seedintegerNo-->=1The random seed to use for the generation.
enablewebsearchbooleanNoFalsetrue, falseEnable web search.

Example request

curl https://media.onerouter.pro/v1/images/generations \
  -H "Authorization: Bearer YOUR_API_KEY" \
  -H "Content-Type: application/json" \
  -d @- <<'EOF'
{
    "model": "google/nano-banana-pro/image-to-image",
    "prompt": "make a photo of the man driving the car down the california coastline.",
    "image_urls": [
        "https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260603%2F53969087-23f8-4faa-a3c2-038bf80febf7.png",
        "https://storage.googleapis.com/infron_gcs/image%2Fplayground-inputs%2F15%2F20260603%2Fa830ea54-af6f-469c-9488-59fca3394d85.png"
    ],
    "n": 1,
    "aspect_ratio": "16:9",
    "resolution": "1K",
    "output_format": "png",
    "response_format": "url",
    "seed": 1,
    "enable_web_search": true
}
EOF

Output

ParameterTypeRangeDescription
codeinteger--Status code of the request.
messagestring--Status message of the request.
dataobject--Data of the task.
data.task_idstring--ID of the task.
data.objectstring--Object type of the task.
data.modelstring--Model name of the task.
data.statusstringcreated, in_progress, processing, completed, failedStatus of the task.
data.fail_reasonstring--Fail reason of the task.
data.submit_timeinteger--Timestamp of the task submission.
data.start_timeinteger--Timestamp of the task start.
data.finish_timeinteger--Timestamp of the task finish.
data.outputsarray--Outputs of the task.
data.created_atstring--Timestamp of the task creation.

Example output

{
  "code": 200,
  "message": "success",
  "data": {
    "task_id": "c4e4039558d8441cb7482d8d1dea668a",
    "object": "image",
    "model": "google/nano-banana-pro/image-to-image",
    "status": "completed",
    "fail_reason": "",
    "submit_time": 1780556227,
    "start_time": 1780556227,
    "finish_time": 1780556257,
    "outputs": [
      "https://storage.googleapis.com/infron_gcs/image%2Fgemini_9f1e67c4-4381-4446-815c-226262c637df.png"
    ],
    "usage": {
      "completion_tokens": 1433,
      "image_count": 1,
      "prompt_tokens": 531,
      "resolution": "1K",
      "total_tokens": 1964,
      "web_search": true
    },
    "cost": {
      "total_cost": 0.138187,
      "cost_details": {
        "prompt_cost": 0,
        "completion_cost": 0,
        "image_cost": 0.138187,
        "video_cost": 0,
        "audio_cost": 0,
        "native_web_search_cost": 0,
        "plugin_web_search_cost": 0,
        "tools_cost": 0,
        "prompt_cache_read_cost": 0,
        "prompt_cache_write_cost": 0,
        "prompt_cache_write_5_min": 0,
        "prompt_cache_write_1_h": 0,
        "reasoning_cost": 0,
        "discount_rate": 1,
        "is_byok": false,
        "byok_cost": 0
      }
    },
    "created_at": "2026-06-04 06:57:07"
  }
}

3. Detailed Pricing

Pricing TypeUnitPrice
Input text1M tokens$2.00
Input image1M tokens$2.00
Input image1 image~$0.0011
Output text / thinking1M tokens$12.00
Output image1M tokens$120.00
ResolutionEstimated Output TokensEstimated Price
1K / 1024×10241,120 tokens$0.134
2K / 2048×20481,120 tokens$0.134
4K / 4096×40962,000 tokens$0.240